if (!defined &_MAC68K_BUS_H_) {
    eval 'sub _MAC68K_BUS_H_ {1;}';
    eval 'sub MAC68K_BUS_SPACE_MEM {0;}';
    eval 'sub bus_space_read_1 {
        local($t, $h, $o) = @_;
        eval "(( &void) $t, (*( &volatile  &u_int8_t *)(($h) + ($o))))";
    }';
    eval 'sub bus_space_read_2 {
        local($t, $h, $o) = @_;
        eval "(( &void) $t, (*( &volatile  &u_int16_t *)(($h) + ($o))))";
    }';
    eval 'sub bus_space_read_4 {
        local($t, $h, $o) = @_;
        eval "(( &void) $t, (*( &volatile  &u_int32_t *)(($h) + ($o))))";
    }';
    if (0 ) {
	eval 'sub bus_space_read_8 {
	    local($t, $h, $o) = @_;
	    eval "!!!  &bus_space_read_8  &unimplemented !!!";
	}';
    }
    eval 'sub bus_space_read_multi_1 {
        local($t, $h, $o, $a, $c) = @_;
        eval " &do { ( &void) $t;  &__asm  &__volatile (\\"								movl	%0,a0					;			movl	%1,a1					;			movl	%2,d0					;		1:	movb	a0@,a1@+				;			subql	#1,d0					;			jne	1b\\" : : \\"r\\" (($h) + ($o)), \\"g\\" ($a), \\"g\\" ($c) : \\"a0\\",\\"a1\\",\\"d0\\"); }  &while (0);";
    }';
    eval 'sub bus_space_read_multi_2 {
        local($t, $h, $o, $a, $c) = @_;
        eval " &do { ( &void) $t;  &__asm  &__volatile (\\"								movl	%0,a0					;			movl	%1,a1					;			movl	%2,d0					;		1:	movw	a0@,a1@+				;			subql	#1,d0					;			jne	1b\\" : : \\"r\\" (($h) + ($o)), \\"g\\" ($a), \\"g\\" ($c) : \\"a0\\",\\"a1\\",\\"d0\\"); }  &while (0);";
    }';
    eval 'sub bus_space_read_multi_4 {
        local($t, $h, $o, $a, $c) = @_;
        eval " &do { ( &void) $t;  &__asm  &__volatile (\\"								movl	%0,a0					;			movl	%1,a1					;			movl	%2,d0					;		1:	movl	a0@,a1@+				;			subql	#1,d0					;			jne	1b\\" : : \\"r\\" (($h) + ($o)), \\"g\\" ($a), \\"g\\" ($c) : \\"a0\\",\\"a1\\",\\"d0\\"); }  &while (0);";
    }';
    if (0 ) {
	eval 'sub bus_space_read_multi_8 {!!!  &bus_space_read_multi_8  &unimplemented !!!;}';
    }
    eval 'sub bus_space_read_region_1 {
        local($t, $h, $o, $a, $c) = @_;
        eval " &do { ( &void) $t;  &__asm  &__volatile (\\"								movl	%0,a0					;			movl	%1,a1					;			movl	%2,d0					;		1:	movb	a0@+,a1@+				;			subql	#1,d0					;			jne	1b\\" : : \\"r\\" (($h) + ($o)), \\"g\\" ($a), \\"g\\" ($c) : \\"a0\\",\\"a1\\",\\"d0\\"); }  &while (0);";
    }';
    eval 'sub bus_space_read_region_2 {
        local($t, $h, $o, $a, $c) = @_;
        eval " &do { ( &void) $t;  &__asm  &__volatile (\\"								movl	%0,a0					;			movl	%1,a1					;			movl	%2,d0					;		1:	movw	a0@+,a1@+				;			subql	#1,d0					;			jne	1b\\" : : \\"r\\" (($h) + ($o)), \\"g\\" ($a), \\"g\\" ($c) : \\"a0\\",\\"a1\\",\\"d0\\"); }  &while (0);";
    }';
    eval 'sub bus_space_read_region_4 {
        local($t, $h, $o, $a, $c) = @_;
        eval " &do { ( &void) $t;  &__asm  &__volatile (\\"								movl	%0,a0					;			movl	%1,a1					;			movl	%2,d0					;		1:	movl	a0@+,a1@+				;			subql	#1,d0					;			jne	1b\\" : : \\"r\\" (($h) + ($o)), \\"g\\" ($a), \\"g\\" ($c) : \\"a0\\",\\"a1\\",\\"d0\\"); }  &while (0);";
    }';
    if (0 ) {
	eval 'sub bus_space_read_region_8 {!!!  &bus_space_read_region_8  &unimplemented !!!;}';
    }
    eval 'sub bus_space_write_1 {
        local($t, $h, $o, $v) = @_;
        eval "(( &void) $t, (( &void)(*( &volatile  &u_int8_t *)(($h) + ($o)) = ($v))))";
    }';
    eval 'sub bus_space_write_2 {
        local($t, $h, $o, $v) = @_;
        eval "(( &void) $t, (( &void)(*( &volatile  &u_int16_t *)(($h) + ($o)) = ($v))))";
    }';
    eval 'sub bus_space_write_4 {
        local($t, $h, $o, $v) = @_;
        eval "(( &void) $t, (( &void)(*( &volatile  &u_int32_t *)(($h) + ($o)) = ($v))))";
    }';
    if (0 ) {
	eval 'sub bus_space_write_8 {!!!  &bus_space_write_8  &not  &implemented !!!;}';
    }
    eval 'sub bus_space_write_multi_1 {
        local($t, $h, $o, $a, $c) = @_;
        eval " &do { ( &void) $t;  &__asm  &__volatile (\\"								movl	%0,a0					;			movl	%1,a1					;			movl	%2,d0					;		1:	movb	a1@+,a0@				;			subql	#1,d0					;			jne	1b\\" : : \\"r\\" (($h) + ($o)), \\"g\\" ($a), \\"g\\" ($c) : \\"a0\\",\\"a1\\",\\"d0\\"); }  &while (0);";
    }';
    eval 'sub bus_space_write_multi_2 {
        local($t, $h, $o, $a, $c) = @_;
        eval " &do { ( &void) $t;  &__asm  &__volatile (\\"								movl	%0,a0					;			movl	%1,a1					;			movl	%2,d0					;		1:	movw	a1@+,a0@				;			subql	#1,d0					;			jne	1b\\" : : \\"r\\" (($h) + ($o)), \\"g\\" ($a), \\"g\\" ($c) : \\"a0\\",\\"a1\\",\\"d0\\"); }  &while (0);";
    }';
    eval 'sub bus_space_write_multi_4 {
        local($t, $h, $o, $a, $c) = @_;
        eval " &do { ( &void) $t;  &__asm  &__volatile (\\"								movl	%0,a0					;			movl	%1,a1					;			movl	%2,d0					;		1:	movl	a1@+,a0@				;			subql	#1,d0					;			jne	1b\\" : : \\"r\\" (($h) + ($o)), \\"g\\" ($a), \\"g\\" ($c) : \\"a0\\",\\"a1\\",\\"d0\\"); }  &while (0);";
    }';
    if (0 ) {
	eval 'sub bus_space_write_multi_8 {
	    local($t, $h, $o, $a, $c) = @_;
	    eval "!!!  &bus_space_write_multi_8  &unimplimented !!!";
	}';
    }
    eval 'sub bus_space_write_region_1 {
        local($t, $h, $o, $a, $c) = @_;
        eval " &do { ( &void) $t;  &__asm  &__volatile (\\"								movl	%0,a0					;			movl	%1,a1					;			movl	%2,d0					;		1:	movb	a1@+,a0@+				;			subql	#1,d0					;			jne	1b\\" : : \\"r\\" (($h) + ($o)), \\"g\\" ($a), \\"g\\" ($c) : \\"a0\\",\\"a1\\",\\"d0\\"); }  &while (0);";
    }';
    eval 'sub bus_space_write_region_2 {
        local($t, $h, $o, $a, $c) = @_;
        eval " &do { ( &void) $t;  &__asm  &__volatile (\\"								movl	%0,a0					;			movl	%1,a1					;			movl	%2,d0					;		1:	movw	a1@+,a0@+				;			subql	#1,d0					;			jne	1b\\" : : \\"r\\" (($h) + ($o)), \\"g\\" ($a), \\"g\\" ($c) : \\"a0\\",\\"a1\\",\\"d0\\"); }  &while (0);";
    }';
    eval 'sub bus_space_write_region_4 {
        local($t, $h, $o, $a, $c) = @_;
        eval " &do { ( &void) $t;  &__asm  &__volatile (\\"								movl	%0,a0					;			movl	%1,a1					;			movl	%2,d0					;		1:	movl	a1@+,a0@+				;			subql	#1,d0					;			jne	1b\\" : : \\"r\\" (($h) + ($o)), \\"g\\" ($a), \\"g\\" ($c) : \\"a0\\",\\"a1\\",\\"d0\\"); }  &while (0);";
    }';
    if (0 ) {
	eval 'sub bus_space_write_region_8 {!!!  &bus_space_write_region_8  &unimplemented !!!;}';
    }
    eval 'sub bus_space_set_multi_1 {
        local($t, $h, $o, $val, $c) = @_;
        eval " &do { ( &void) $t;  &__asm  &__volatile (\\"								movl	%0,a0					;			movl	%1,d1					;			movl	%2,d0					;		1:	movb	d1,a0@					;			subql	#1,d0					;			jne	1b\\" : : \\"r\\" (($h) + ($o)), \\"g\\" ($val), \\"g\\" ($c) : \\"a0\\",\\"d0\\",\\"d1\\"); }  &while (0);";
    }';
    eval 'sub bus_space_set_multi_2 {
        local($t, $h, $o, $val, $c) = @_;
        eval " &do { ( &void) $t;  &__asm  &__volatile (\\"								movl	%0,a0					;			movl	%1,d1					;			movl	%2,d0					;		1:	movw	d1,a0@					;			subql	#1,d0					;			jne	1b\\" : : \\"r\\" (($h) + ($o)), \\"g\\" ($val), \\"g\\" ($c) : \\"a0\\",\\"d0\\",\\"d1\\"); }  &while (0);";
    }';
    eval 'sub bus_space_set_multi_4 {
        local($t, $h, $o, $val, $c) = @_;
        eval " &do { ( &void) $t;  &__asm  &__volatile (\\"								movl	%0,a0					;			movl	%1,d1					;			movl	%2,d0					;		1:	movl	d1,a0@					;			subql	#1,d0					;			jne	1b\\" : : \\"r\\" (($h) + ($o)), \\"g\\" ($val), \\"g\\" ($c) : \\"a0\\",\\"d0\\",\\"d1\\"); }  &while (0);";
    }';
    if (0 ) {
	eval 'sub bus_space_set_multi_8 {!!!  &bus_space_set_multi_8  &unimplemented !!!;}';
    }
    eval 'sub bus_space_set_region_1 {
        local($t, $h, $o, $val, $c) = @_;
        eval " &do { ( &void) $t;  &__asm  &__volatile (\\"								movl	%0,a0					;			movl	%1,d1					;			movl	%2,d0					;		1:	movb	d1,a0@+					;			subql	#1,d0					;			jne	1b\\" : : \\"r\\" (($h) + ($o)), \\"g\\" ($val), \\"g\\" ($c) : \\"a0\\",\\"d0\\",\\"d1\\"); }  &while (0);";
    }';
    eval 'sub bus_space_set_region_2 {
        local($t, $h, $o, $val, $c) = @_;
        eval " &do { ( &void) $t;  &__asm  &__volatile (\\"								movl	%0,a0					;			movl	%1,d1					;			movl	%2,d0					;		1:	movw	d1,a0@+					;			subql	#1,d0					;			jne	1b\\" : : \\"r\\" (($h) + ($o)), \\"g\\" ($val), \\"g\\" ($c) : \\"a0\\",\\"d0\\",\\"d1\\"); }  &while (0);";
    }';
    eval 'sub bus_space_set_region_4 {
        local($t, $h, $o, $val, $c) = @_;
        eval " &do { ( &void) $t;  &__asm  &__volatile (\\"								movl	%0,a0					;			movl	%1,d1					;			movl	%2,d0					;		1:	movl	d1,a0@+					;			subql	#1,d0					;			jne	1b\\" : : \\"r\\" (($h) + ($o)), \\"g\\" ($val), \\"g\\" ($c) : \\"a0\\",\\"d0\\",\\"d1\\"); }  &while (0);";
    }';
    if (0 ) {
	eval 'sub bus_space_set_region_8 {!!!  &bus_space_set_region_8  &unimplemented !!!;}';
    }
    eval 'sub bus_space_copy_1 {
        local($t, $h1, $o1, $h2, $o2, $c) = @_;
        eval " &do { ( &void) $t;  &__asm  &__volatile (\\"								movl	%0,a0					;			movl	%1,a1					;			movl	%2,d0					;		1:	movb	a0@+,a1@+				;			subql	#1,d0					;			jne	1b\\" : : \\"r\\" (($h1) + ($o1)), \\"r\\" (($h2) + ($o2)), \\"g\\" ($c) : \\"a0\\",\\"a1\\",\\"d0\\"); }  &while (0);";
    }';
    eval 'sub bus_space_copy_2 {
        local($t, $h1, $o1, $h2, $o2, $c) = @_;
        eval " &do { ( &void) $t;  &__asm  &__volatile (\\"								movl	%0,a0					;			movl	%1,a1					;			movl	%2,d0					;		1:	movw	a0@+,a1@+				;			subql	#1,d0					;			jne	1b\\" : : \\"r\\" (($h1) + ($o1)), \\"r\\" (($h2) + ($o2)), \\"g\\" ($c) : \\"a0\\",\\"a1\\",\\"d0\\"); }  &while (0);";
    }';
    eval 'sub bus_space_copy_4 {
        local($t, $h1, $o1, $h2, $o2, $c) = @_;
        eval " &do { ( &void) $t;  &__asm  &__volatile (\\"								movl	%0,a0					;			movl	%1,a1					;			movl	%2,d0					;		1:	movl	a0@+,a1@+				;			subql	#1,d0					;			jne	1b\\" : : \\"r\\" (($h1) + ($o1)), \\"r\\" (($h2) + ($o2)), \\"g\\" ($c) : \\"a0\\",\\"a1\\",\\"d0\\"); }  &while (0);";
    }';
    if (0 ) {
	eval 'sub bus_space_copy_8 {!!!  &bus_space_copy_8  &unimplemented !!!;}';
    }
    eval 'sub bus_space_barrier {
        local($t, $h, $o, $l, $f) = @_;
        eval "(( &void)(( &void)($t), ( &void)($h), ( &void)($o), ( &void)($l), ( &void)($f)))";
    }';
    eval 'sub BUS_BARRIER_READ {0x01;}';
    eval 'sub BUS_BARRIER_WRITE {0x02;}';
}
1;
